Program Gauss_Newton_Marquardt(Output);
{$A+,B-,D+,S+,V+,I+,R-,M 16384,0,655360}
{$IFDEF CPU87}
{$IFDEF R} {$N-,E-} {$ELSE} {$N+,E-} {$ENDIF}
{$ELSE}
{$IFDEF R} {$N-,E-} {$ELSE} {$N+,E+} {$ENDIF}
{$ENDIF}
Uses Crt,Dos,Zita4all;
Const    bufsize = 8192;
nmax = 900;
nmax1 = 901;
pmaxper256 = 99;
blocksize:LongInt = 65400;
{$IFDEF S} size=4;explow=-100.0; {$ENDIF}
{$IFDEF R} size=6;explow=-87.0; {$ENDIF}
{$IFDEF D} size=8;explow=-730.0; {$ENDIF}
{$IFNDEF R}
{$IFNDEF S}
{$IFNDEF D} size=10;explow=-11340.0; {$ENDIF}
{$ENDIF}
{$ENDIF}
Type    Buffer = Array[1..bufsize] Of Byte;
FileName = String[100];
PBlock = ^NextBlock;
NextBlock = Record
nul:^Real; away:PBlock
End;
Matrix = Record
nul:^Real; away:PBlock; r0,c0,cn:LongInt
End;
Var  cols,maxi,m,i,j,k,l,n,n1:Integer;
le,nd:LongInt;
l1,fit,sd,x1,r1,trace,
weight,lambda,fo,fl,nl,fd,
s2u,corr,coeff,rsq,msc,
lambda0,sco,het,ske,cur:Real;
z:Char;
er:Boolean;
heap0:Pointer;
pb,pbhelp:PBlock;
t,s:Array[0..pmaxper256] Of Set Of 0..255;
xs,name,pr2,rs,res,rt,rh:PathStr;
tmp,dat,out:Text;
kn:Array[1..nmax] Of Integer;
b,x,kr:Array[1..nmax1] Of Real;
a,c:Matrix;
ks:Array[1..nmax] Of String[3];
iw:Array[0..9] Of Text;
bd,od:^Buffer;
bw:Array[0..9] Of ^Buffer;
dirinfo:SearchRec;
Procedure LowMemory;
Begin
{$IFDEF MSDOS}  Release(heap0); {$ENDIF}
Messages[1]:='There is not enough memory for the matrices!';
Writeln(Output,Messages[1]);Halt(60)
End;
Procedure PlaceMatrix(ri,ci,ra,ca:LongInt; Var m:Matrix);
Var h,i:LongInt;
Begin
h:=(ra-ri+1)*(ca-ci+1)*size;
m.r0:=ri;m.c0:=ci;m.cn:=ca-ci+1;
If h <= blocksize
Then If MaxAvail >= h Then GetMem(m.nul,h) Else LowMemory
Else Begin
If MaxAvail >= blocksize
Then GetMem(m.nul,blocksize)
Else LowMemory;
If MaxAvail >= SizeOf(pb^) Then New(pb) Else LowMemory;
m.away:=pb;
Dec(h,blocksize);
Repeat
If h <= blocksize Then i:=h Else i:=blocksize;
Dec(h,i);
If MaxAvail >= i Then GetMem(pb^.nul,i) Else LowMemory;
If h <> 0 Then Begin
If MaxAvail >= SizeOf(pbhelp)
Then New(pbhelp)
Else LowMemory;
pb^.away:=pbhelp;pb:=pbhelp
End 
Until h = 0;
End 
End;
Function ActP(m:Matrix; h:LongInt):Pointer;
Var i,j,k:LongInt;
Begin
If h < blocksize
Then ActP:=Ptr(Seg(m.nul^),Ofs(m.nul^)+h)
Else Begin
pb:=m.away;
k:=h Mod blocksize;j:=(h Div blocksize)-1;
If j > 0 Then For i:=1 To j Do pb:=pb^.away;
ActP:=Ptr(Seg(pb^.nul^),Ofs(pb^.nul^)+k)
End 
End;
Function GetE(m:Matrix; r,c:LongInt):Real;
Var p:^Real;
Begin
p:=ActP(m,((r-m.r0)*m.cn+c-m.c0)*size);GetE:=p^
End;
Procedure SetE(m:Matrix; r,c:LongInt; value:Real);
Var p:^Real;
Begin
p:=ActP(m,((r-m.r0)*m.cn+c-m.c0)*size);p^:=value
End;
Procedure CopyFile(source,target:PathStr);
Var  ir,iw:Word;
l:LongInt;
s,t:File;
buffer:Array[1..8192] Of Char;
Begin
For ir:=1 To Length(source) Do source[ir]:=UpCase(source[ir]);
For ir:=1 To Length(target) Do target[ir]:=UpCase(target[ir]);
If source = target Then Exit;
Assign(s,source);
{$I-}
Reset(s,1);
If IOResult <> 0 Then Begin
Messages[1]:=source+' file does not exist!';
Writeln(Output,Messages[1]);Halt(64)
End;
{$I+}
If source[2] = ':' Then ir:=Ord(UpCase(source[1]))-64 Else ir:=0;
l:=FileSize(s);
If l > DiskFree(ir)
Then Begin
Messages[1]:=source+' file is bigger than the free space!';
Writeln(Output,Messages[1]);Halt(57)
End;
Assign(t,target);Rewrite(t,1);
Write(Output,'Copying ',l,' bytes');
Writeln(Output,' from ',source,' to ',target,'.');
Repeat
BlockRead(s,buffer,SizeOf(buffer),ir);
BlockWrite(t,buffer,ir,iw);
Until (ir = 0) Or (ir <> iw);
Close(t);Close(s)
End;
Function SetEmpty:Boolean;
Var i:Integer;
b:Boolean;
Begin
b:=True;
For i:=0 To pmaxper256 Do b:=b And (s[i] = []);
SetEmpty:=b
End;
Procedure Inverse;
Var i,j,k:Integer;
Begin
For k:=n Downto 1 Do Begin
If GetE(a,1,1) <= 0.0 Then Begin
er:=True;Exit
End;
SetE(a,0,n,1.0/GetE(a,1,1));
For i:=2 To n Do Begin
r1:=GetE(a,i,1)*GetE(a,0,n);
If i > k Then SetE(a,0,i-1,r1) Else SetE(a,0,i-1,-r1);
For j:=2 To i Do
SetE(a,i-1,j-1,GetE(a,i,j)+GetE(a,i,1)*GetE(a,0,j-1))
End;
For i:=1 To n Do SetE(a,n,i,GetE(a,0,i))
End;
For i:=1 To n-1 Do
For j:=i+1 To n Do SetE(a,i,j,GetE(a,j,i));
er:=False
End;
Procedure Matmulti;
Var i,j,k:Integer;
r:Real;
Begin
Writeln(Output,'Matrix inversion is being checked ...');
For i:=1 To n Do Begin
For j:=1 To n Do Begin
r1:=0;
For k:=1 To n Do r1:=r1+GetE(a,i,k)*GetE(c,k,j);
r:=Abs(r1);If i=j Then r:=Abs(r-1.0);
If r >= 0.001 Then
Writeln(Output,
'I[',i,',',j,']=',r1:6:3,' may not be appropriate!')
End 
End 
End;
Function Fdist(nobs,nfit:LongInt):Real;
Var a,b,x0,x1,x01,fx0,fx1,fx01:Real;
Function Bi(a,b,x:Real):Real;
Var bt:Real;
go:Boolean;
Function Gln(xx:Real):Real;
Const stp = 2.50662827465;
Var x,tmp,ser:Real;
Begin
x:=xx-1.0;
tmp:=x+5.5;
tmp:=(x+0.5)*Ln(tmp)-tmp;
ser:=1.0+76.18009173/(x+1.0)-86.50532033/(x+2.0)
+24.01409822/(x+3.0)-1.231739516/(x+4.0)
+0.00120858003/(x+5.0)-5.36382E-6/(x+6.0);
Gln:=tmp+Ln(stp*ser)
End;
Function Bcf(a,b,x:Real):Real;
Const im = 100; eps = 1.0E-6;
Var tem,qap,qam,qab,em,d,bz,bpp,bp,bm,az,app,am,aold,ap:Real;
m:Integer;
Begin
am:=1.0;bm:=1.0;az:=1.0;
qab:=a+b;qap:=a+1.0;qam:=a-1.0;bz:=1.0-qab*x/qap;
m:=0;
Repeat
Inc(m);
em:=m;tem:=em+em;
d:=em*(b-m)*x/((qam+tem)*(a+tem));
ap:=az+d*am;bp:=bz+d*bm;
d:=-(a+em)*(qab+em)*x/((a+tem)*(qap+tem));
app:=ap+d*az;bpp:=bp+d*bz;aold:=az;
am:=ap/bpp;bm:=bp/bpp;az:=app/bpp;bz:=1.0
Until (Abs(az-aold) < eps*Abs(az)) Or (m = im);
If m = im
Then Begin
Bcf:=-1.0;go:=False
End 
Else Begin
Bcf:=az;go:=True
End 
End;
Begin
If (x <= 0.0) Or (x >= 1.0)
Then bt:=0.0
Else Begin
bt:=Gln(a+b)-Gln(a)-Gln(b)+a*Ln(x)+b*Ln(1.0-x);
If bt < explow
Then bt:=0.0
Else bt:=Exp(Gln(a+b)-Gln(a)-Gln(b)+a*Ln(x)+b*Ln(1.0-x))
End;
If x < (a+1.0)/(a+b+2.0)
Then Begin
Bi:=bt*Bcf(a,b,x)/a;
If Not go Then Bi:=-1.0
End 
Else Begin
Bi:=1.0-bt*Bcf(b,a,1.0-x)/b;
If Not go Then Bi:=-1.0
End 
End;
Begin
a:=(nobs-n)/2.0;b:=nfit/2.0;
x0:=0.0;x1:=1.0;fx0:=-0.05;fx1:=0.95;
Repeat
x01:=(x0+x1)/2.0;
fx01:=Bi(a,b,x01)-0.05;
If fx0*fx01 <= 0.0
Then Begin
fx1:=fx01;x1:=x01
End 
Else Begin
fx0:=fx01;x0:=x01
End 
Until ((x1-x0) <= 1.0E-5) Or (fx01 = 0.0) Or (fx01 < -1.0);
If fx01 < -1.0
Then Fdist:=-1.0
Else Fdist:=(1-x01)*(nobs-n)/x01/nfit
End;
Procedure Err(Var a:Real);
Begin
If a > 1.0E30 Then Writeln(out,' ??') Else Writeln(out,a:ac);
End;
Begin
ExitSave:=ExitProc;
ExitProc:=@Error_Handling;
ProgramName:='GNM';
Messages[1]:='';Messages[2]:='';Messages[3]:='';Messages[4]:='';
Environment;
maxi:=0;m:=0;
rs:=ParamStr(1);pr2:=ParamStr(2);
If Length(rs) > 0 Then For i:=1 To Length(rs) Do rs[i]:=UpCase(rs[i]);
{$IFDEF MSDOS}  Mark(heap0); {$ENDIF}
New(bd);New(od);
For i:=0 To 9 Do New(bw[i]);
If (rs = '*') Or (Pos('.ODE',rs) <> 0)
Then Begin
If rs = '*'
Then Begin
Assign(dat,ZitaTemp+'\'+'Odes.pas');
Is_not_it(ZitaTemp+'\Odes.pas',dat);
Repeat
Readln(dat,res);
For i:=1 To Length(res) Do res[i]:=UpCase(res[i]);
i:=Pos('P=',res);j:=Pos('P =',res)
Until SeekEof(dat) Or (i <> 0) Or (j <> 0);
If (i = 0) And (j = 0)
Then Begin
Messages[1]:='The value of p cannot be found in ODES.PAS!';
Writeln(Output,Messages[1]);Halt(67)
End 
Else Begin
If i < j Then i:=j;
While Not (res[i] In ['0'..'9']) Do Inc(i);
j:=i;
While res[j] In ['0'..'9'] Do Inc(j);
res:=Copy(res,i,j-i);Val(res,m,i)
End 
End 
Else Begin
Assign(dat,ZitaTemp+'\'+rs);Is_not_it(ZitaTemp+'\'+rs,dat);
Read(dat,m,i);
If Not SeekEoln(dat) Then Begin
Read(dat,i);If Not SeekEoln(dat) Then Readln(dat,m)
End 
End;
Close(dat);
Assign(dat,ZitaTemp+'\'+'Paramtrs.dat');
Is_not_it(ZitaTemp+'\Paramtrs.dat',dat);
n1:=1;For i:=0 To pmaxper256 Do s[i]:=[];
For i:=1 To Length(pr2) Do pr2[i]:=UpCase(pr2[i]);
If pr2 = ''
Then
For i:=1 To m Do Begin
Read(dat,kr[n1]);res:=' ';
If Not SeekEoln(dat) Then Readln(dat,res) Else Readln(dat);
While (res[1] <= ' ') And (Length(res) > 1) Do Delete(res,1,1);
If res[1] = '*' Then Begin
kn[n1]:=i;Str(i,ks[n1]);Inc(n1);
s[i Div 256]:=s[i Div 256]+[i Mod 256]
End 
End 
Else Begin
i:=0;j:=0;
While (j = 0) And (i <= EnvCount) Do Begin
Inc(i);If Pos(pr2+'=',EnvStr(i)) <> 0 Then j:=1;
End;
If j = 0 Then Begin
Messages[1]:='The environment variable named '+pr2+
' does not exist!';
Writeln(Output,Messages[1]);Halt(66)
End;
res:= GetEnv(pr2);
i:=1;
While 0 < Length(res) Do Begin
While (Not (res[1] In ['0'..'9'])) And (0 < Length(res)) Do
Delete(res,1,1);
While (res[i] In ['0'..'9']) And (i <= Length(res)) Do Inc(i);
i:=i-1;
If i <= Length(res) Then Begin
ks[n1]:=Copy(res,1,i);Delete(res,1,i);Inc(n1);i:=1
End 
End;
For i:=1 To n1-1 Do Begin
FindFirst('J'+ks[i]+'.col',AnyFile,dirinfo);
If DosError = 18 Then Begin
Messages[1]:='The environment variable named '+pr2+'has';
Messages[2]:='a wrong value or a J*.col file does not exist!';
Writeln(Output,Messages[1]);Writeln(Output,Messages[2]);
Halt(65)
End;
While ks[i][1] = ' ' Do Delete(ks[i],1,1);
Val(ks[i],kn[i],k);
s[kn[i] Div 256]:=s[kn[i] Div 256]+[kn[i] Mod 256]
End;
For i:=1 To n1-2 Do
For j:=1 To n1-1-i Do
If kn[j] > kn[j+1] Then Begin
k:=kn[j+1];kn[j+1]:=kn[j];kn[j]:=k;
rh:=ks[j+1];ks[j+1]:=ks[j];ks[j]:=rh
End;
j:=1;
For i:=1 To m Do
If (i Mod 256) In s[i Div 256] Then Begin
Readln(dat,kr[j]);Inc(j)
End 
Else Readln(dat)
End;
n:=n1-1;t:=s;
Readln(dat,lambda0,l1);lambda:=Abs(lambda0);
Readln(dat,fo,fl,nl);Readln(dat,maxi);
Close(dat)
End 
Else Begin
Write(Output,'Number of changed parameters ? ');Readln(Input,n);
n1:=n+1;For i:=0 To pmaxper256 Do s[i]:=[];
For i:=1 To n Do Begin
Write(Output,'Number of ',i,'. k=');Readln(Input,ks[i]);
While ks[i][1] = ' ' Do Delete(ks[i],1,1);
Val(ks[i],kn[i],j);
s[kn[i] Div 256]:=s[kn[i] Div 256]+[kn[i] Mod 256]
End;
For i:=1 To n1-2 Do
For j:=1 To n1-1-i Do
If kn[j] > kn[j+1] Then Begin
k:=kn[j+1];kn[j+1]:=kn[j];kn[j]:=k;
rh:=ks[j+1];ks[j+1]:=ks[j];ks[j]:=rh
End;
t:=s;
Write(Output,'Marquardt parameter = ');Read(Input,lambda0);
lambda:=Abs(lambda0);
Write(Output,'Acceptable relative step = ');Read(Input,l1);
fo:=-1.0;
Close(dat);
Assign(dat,ZitaTemp+'\paramtrs.dat');SetTextBuf(dat,bd^,bufsize);
Is_not_it(ZitaTemp+'\Paramtrs.dat',dat);
i:=0;
While Not SetEmpty Do Begin
Inc(i);
If (i Mod 256) In s[i Div 256]
Then Begin
For j:=1 To n Do If kn[j] = i Then Readln(dat,kr[j]);
s[i Div 256]:=s[i Div 256]-[i Mod 256]
End 
Else Readln(dat)
End;
Close(dat)
End;
If n = 0 Then Halt;
res:=Copy(FExpand(ZitaRd),1,1);z:=res[1];
cols:=(n Div 10)+1;
For i:=1 To n Do Begin
k:= (i-1) Div cols;l:=(i-1) Mod cols;
If l = 0
Then Begin
Str(k,rh);
FindFirst(ZitaTemp+'\j'+ks[i]+'.col',AnyFile,dirinfo);
If (DiskFree(Ord(z)-64) > (dirinfo.Size+4096)) And (cols > 1)
And (z > Copy(FExpand(ZitaTemp),1,1)) And (DosError = 0)
Then res:=ZitaRd
Else res:=ZitaTemp;
rh:=res+'\tmp'+rh;
CopyFile(ZitaTemp+'\j'+ks[i]+'.col',rh)
End 
Else Begin
Assign(iw[0],rh);SetTextBuf(iw[0],bw[0]^,bufsize);Reset(iw[0]);
Assign(dat,ZitaTemp+'\j'+ks[i]+'.col');
SetTextBuf(dat,bd^,bufsize);
Is_not_it(ZitaTemp+'\J'+ks[i]+'.col',dat);
FindFirst(rh,AnyFile,dirinfo);le:=4096+dirinfo.Size;
FindFirst(ZitaTemp+'\j'+ks[i]+'.col',AnyFile,dirinfo);
Inc(le,dirinfo.Size);
If (DiskFree(Ord(z)-64) > le) And
(z > Copy(FExpand(ZitaTemp),1,1)) And (DosError = 0)
Then res:=ZitaRd
Else res:=ZitaTemp;
Str(k,rh);rh:=res+'\tmp'+rh;
Assign(out,res+'\tmp');SetTextBuf(out,od^,bufsize);Rewrite(out);
Repeat
For j:=1 To l Do Begin
Readln(iw[0],xs);
If xs = '' Then Readln(iw[0],xs);
Writeln(out,xs)
End;
Readln(dat,xs);
If xs = '' Then Readln(dat,xs);
Writeln(out,xs)
Until SeekEof(iw[0]);
Close(iw[0]);Close(dat);Close(out);
Erase(iw[0]);
Assign(tmp,res+'\tmp');Rename(tmp,res+'\tmp'+rh[Length(rh)])
End;
If ((l = (cols-1)) Or (i = n)) And
(res = ZitaRd) And (res <> ZitaTemp) Then Begin
Str(k,res);res:=ZitaTemp+'\tmp'+res;CopyFile(rh,res);
Assign(tmp,rh);Erase(tmp)
End 
End;
Assign(dat,ZitaTemp+'\j.col');SetTextBuf(dat,bd^,bufsize);
Is_not_it(ZitaTemp+'\J.col',dat);
For i:=0 To k Do Begin
Str(i,rh);
Assign(iw[i],ZitaTemp+'\tmp'+rh);SetTextBuf(iw[i],bw[i]^,bufsize);
Reset(iw[i])
End;
i:=0;
If fo < 0.0
Then Begin
FindFirst(ZitaTemp+'\result.*',AnyFile,dirinfo);rh:='1';
While DosError = 0 Do Begin
Assign(tmp,ZitaTemp+'\'+dirinfo.Name);Erase(tmp);FindNext(dirinfo)
End;
name:=ZitaTemp+'\result.1';If maxi = 1 Then maxi:=-1
End 
Else Begin
Repeat
Inc(i);Str(i,rh);
FindFirst(ZitaTemp+'\result.'+rh,AnyFile,dirinfo)
Until DosError = 18;
name:=ZitaTemp+'\result.'+rh;If maxi <= i Then maxi:=-1
End;
Assign(out,ZitaTemp+'\tmp.col');SetTextBuf(out,od^,bufsize);
Rewrite(out);
If i = 1 Then Begin
Writeln(out,
'Warning! The value of fitting parameter is greater then zero');
Writeln(out,'before the first iteration!');Writeln(out)
End;
Writeln(Output,'Maximum number of the fitted parameters: ',
Trunc((Sqrt(8175*(MaxAvail-8.0)/size/4088+1)-3)/2));
PlaceMatrix(0,0,n,n1,a);PlaceMatrix(0,0,n,n1,c);
Write(out,'ITERATION '+rh);rt:=rh;
For i:=0 To n Do
For j:=0 To n1 Do SetE(a,i,j,0.0);
Read(dat,i);
Repeat
Readln(dat,nd,r1,weight);weight:=Sqr(weight);
For i:=1 To nd Do Begin
Readln(dat,b[n1]);
For j:=1 To n Do Readln(iw[(j-1) Div cols],b[j]);
For j:=1 To n Do Begin
For k:=1 To j Do SetE(a,j,k,GetE(a,j,k)+b[j]*weight*b[k]);
SetE(a,j,n1,GetE(a,j,n1)+b[j]*weight*b[n1])
End 
End;
Read(dat,i)
Until i = 0;
Readln(dat);Readln(dat,res);
For i:=0 To (n-1) Div cols Do Begin
Close(iw[i]);
Str(i,rh);Assign(tmp,ZitaTemp+'\tmp'+rh);Erase(tmp)
End;
(* norm of matrix *)
trace:=0.0;
For i:=1 To n Do trace:=trace+GetE(a,i,i);
trace:=trace/n/1000.0;
For i:=1 To n Do
If GetE(a,i,i) <= trace
Then SetE(a,i,0,1.0)
Else SetE(a,i,0,Sqrt(GetE(a,i,i)));
For i:=1 To n Do
For j:=1 To n Do SetE(a,i,j,GetE(a,i,j)/GetE(a,i,0)/GetE(a,j,0));
For i:=0 To n Do
For j:=0 To n1 Do SetE(c,i,j,GetE(a,i,j));
For i:=1 To n Do
For j:=i+1 To n Do SetE(c,i,j,GetE(c,j,i));
(* Marquardt method & matrix inversion *)
Repeat
Repeat
For i:=1 To n Do SetE(a,i,i,GetE(a,i,i)+lambda);
Inverse;
If er Then Begin
If lambda = 0.0 Then lambda:=0.01 Else lambda:=10.0*lambda;
For i:=0 To n Do
For j:=0 To n1 Do SetE(a,i,j,GetE(c,i,j));
End 
Until Not er;
For i:=1 To n Do SetE(c,i,i,GetE(c,i,i)+lambda);
Matmulti;
For i:=1 To n Do SetE(c,i,i,GetE(c,i,i)-lambda);
For i:=1 To n Do Begin
r1:=0.0;
For j:=1 To n Do r1:=r1+GetE(a,i,j)/GetE(c,j,0)*GetE(a,j,n1);
x[i]:=r1/GetE(c,i,0)
End;
x1:=1.0;
For i:=1 To n Do If x1*x[i] <= -0.95 Then x1:=-0.95/x[i];
For i:=0 To n Do
For j:=0 To n1 Do SetE(a,i,j,GetE(c,i,j));
If x1 < l1 Then Begin
If lambda = 0.0 Then lambda:= 0.01 Else lambda:=2.0*lambda
End 
Until x1 > l1;
Inverse;
If er Then Begin
Messages[1]:='There is a wrong Hess-matrix!';
Write(Output,Messages[1]);Halt(90)
End;
Matmulti;
i:=19;
While res[i] = ' ' Do Inc(i);
j:=i;
While res[j] > ' ' Do Inc(j);
Val(Copy(res,i,j-i),nd,k);
i:=j;
While res[i] <> '=' Do Inc(i);
Inc(i);
While res[i] <= ' ' Do Inc(i);
j:=i;
While res[j] > ' ' Do Inc(j);
Val(Copy(res,i,j-i),fit,k);
fit:=fit*Sqrt(nd/(nd-n));
For i:=1 To 9 Do Begin
Read(dat,z);While z <> '=' Do Read(dat,z);
Case i Of
1:Readln(dat,s2u);
2:Readln(dat,corr);
3:Readln(dat,coeff);
4:Readln(dat,rsq);
5:Readln(dat,msc);
6:Readln(dat,sco);
7:Readln(dat,het);
8:Readln(dat,ske);
9:Readln(dat,cur)
End 
End;
s2u:=s2u*Sqrt(nd/(nd-n));
msc:=msc-2.0*n/nd;
Close(dat);
Writeln(out,';     WSTD:',fit:18,';    NMD:',nd,';    MP:',lambda:12);
If rt = '1' Then Begin
Assign(dat,ZitaTemp+'\paramtrs.dat');SetTextBuf(dat,bd^,bufsize);
Reset(dat);
i:=0;
Writeln(out);Writeln(out,'******** Initial Parameter Value(s):');
Repeat
Inc(i);Readln(dat,r1);Writeln(out,'p',i,'o','= ':5,r1:ac);
Until SeekEoln(dat);
Close(dat)
End;
k:=10; {$IFNDEF R} Inc(k,2); {$ENDIF}
Writeln(out);
Writeln(out,'******** Result(s):');
Writeln(out,'Estimate':15,'Std. Err.   (abs & %)':ac+14,'dp':k);
For i:=1 To n Do Begin
x[i]:=kr[i]*x1*x[i];
sd:=fit*Sqrt(GetE(a,i,i)/Sqr(GetE(c,i,0)));
Writeln(out,'p'+ks[i]+' ':5,kr[i]+x[i]:ac,' ',
Abs(sd*(kr[i]+x[i])):k+2,'  &  ',100.0*sd:8:2,' ':4,x[i]:k);
End;
Writeln(out);
Writeln(out,'******** Goodness-of-Fit Statistics:');
Writeln(out,'Marquardt Parameter:':51,lambda:k);
Writeln(out,'Relative Step:':51,x1:7:4);
Writeln(out,'Number of Measured Data: ':52,nd);
Writeln(out,'Number of Fitted Parameters: ':52,n);
Writeln(out,'Weighted Standard Deviation of Data:':51,fit:ac);
Writeln(out,'Unweighted Standard Deviation of Data:':51,s2u:ac);
Write(out,'Correlation between Measured and Calculated Values:');
Err(corr);
Write(out,'Coefficient of Determination:':51);Err(coeff);
Write(out,'R-squared:':51);Err(rsq);
Write(out,'Model Selection Criterion:':51);Err(msc);
Writeln(out);
Writeln(out,'******** Residual Analysis:');
Write(out,'Serial Correlation:':19);Err(sco);
Write(out,'Heteroscedactivity:':19);Err(het);
Write(out,'Skewness:':19);Err(ske);
Write(out,'Kurtosis:':19);Err(cur);
Writeln(out);
Writeln(out,'******** Correlation Matrix (rij\Ri\Sij):');
Writeln(out,
'(Others Are Fixed\Dependence from Others\Others Are Fitted)');
Write(out,'    ');
For i:=1 To n Do Write(out,'p'+ks[i]:6);
Writeln(out);
For i:=1 To n Do Begin
Write(out,'p'+ks[i]:4,' ');
If i=1 Then Write(out,'{') Else Write(out,' ');
For j:=1 To n Do Begin
If i = j Then sd:=Sqrt(1.0-1.0/GetE(a,i,i)/GetE(c,i,i));
If i < j Then sd:=GetE(a,i,j)/Sqrt(GetE(a,i,i)*GetE(a,j,j));
If i > j Then sd:=-GetE(c,i,j)/Sqrt(GetE(c,i,i)*GetE(c,j,j));
Str(sd:6:3,res);
If res[2] = '0' Then Delete(res,2,1) Else Delete(res,6,1);
If i = j
Then res:=res+'}'
Else If (i-j) =1 Then res:=res+'{' Else res:=res+' ';
Write(out,res)
End;
Writeln(out)
End;
If (n >= 1) And (nd > n) Then Begin
fd:=Fdist(nd,1);
If fd >= 0.0 Then Begin
Writeln(out);
Writeln(out,'******** 95% Univariate Confidence Interval(s):');
For i:=1 To n Do Begin
sd:=fit*Sqrt(GetE(a,i,i)/Sqr(GetE(c,i,0))*fd);
Writeln(out,'p'+ks[i]+' ':5,(kr[i]+x[i])*(1.0-sd):ac,' -',
(kr[i]+x[i])*(1.0+sd):ac);
End 
End;
fd:=n*Fdist(nd,n);
If fd >=0.0 Then Begin
Writeln(out);
Writeln(out,
'******** 95% Supporting Plane Confidence Interval(s):');
For i:=1 To n Do Begin
sd:=fit*Sqrt(GetE(a,i,i)/Sqr(GetE(c,i,0))*fd);
Writeln(out,'p'+ks[i]+' ':5,(kr[i]+x[i])*(1.0-sd):ac,' -',
(kr[i]+x[i])*(1.0+sd):ac);
End 
End 
End;
Writeln(out);
rh:='he relative change of WSTD =';
rt:='A relation for the normal termination is fulfilled:';
sd:=Abs((fo-fit)/fo);
If sd < fl
Then Begin
Writeln(out,rt);Writeln(out,'  t',rh,sd:12,' <',fl:12,'.')
End 
Else Writeln(out,'T',rh,sd:12,' >=',fl:12,'.');
sd:=0;
For i:=1 To n Do sd:=sd+Sqr(x[i]/kr[i]);
sd:=Sqrt(sd/n);
Writeln(out);rh:='he relative change of the norm of parameters =';
If sd < nl
Then Begin
Writeln(out,rt);Writeln(out,'  t',rh,sd:12,' <',nl:12,'.')
End 
Else Writeln(out,'T',rh,sd:12,' >=',nl:12,'.');
Writeln(out);
If maxi < 0 Then Begin
Writeln(out,'The maximum number of iterations has been reached.');
If (Abs((fo-fit)/fo) >= fl) And (sd >= nl) Then
Writeln(out,'The minimum is not reached probably!');
Writeln(out)
End;
Close(out);Rename(out,name);
If (sd < 0.1) Or ((fo >= 0.0) And (fit < fo))
Then lambda:=lambda/10.0;
Assign(dat,ZitaTemp+'\paramtrs.dat');SetTextBuf(dat,bd^,bufsize);
Reset(dat);
Assign(out,ZitaTemp+'\res1');SetTextBuf(out,od^,bufsize);Rewrite(out);
k:=0;l:=1;
Repeat
Inc(k);
Readln(dat,x1);
If (k Mod 256) In t[k Div 256]
Then Begin
Write(out,kr[l]+x[l]:ac,' ');
If (m <> 0) And (pr2 = '')
Then Write(out,'* ') Else Write(out,'  ');
Writeln(out,'p',k);Inc(l)
End 
Else Writeln(out,x1:ac,'   p',k)
Until SeekEof(dat) Or ((m > 0) And (k = m));
If m > 0 Then Begin
If lambda > 0.01 Then lambda:=0.01;
Writeln(out);
If lambda0 >= 0.0
Then Writeln(out,lambda:14,l1:8:2)
Else Writeln(out,lambda0:14,l1:8:2);
Writeln(out,fit:ac,' ',fl,' ',nl);Writeln(out,maxi)
End;
Close(dat);Close(out);
If (ParamCount > 0) And (((fo >= 0.0) And ((Abs((fo-fit)/fo) < fl) Or
(sd < nl))) Or (maxi < 0))
Then Begin
Assign(tmp,ZitaTemp+'\res1');Erase(tmp);
End;
{$IFDEF MSDOS}  Release(HeapOrg) {$ENDIF}
End.
End.
