Program Jacobian(Input,Output); {$A+,B-,D+,S+,V+,I+,R-}
{$IFDEF CPU87}
{$IFDEF R} {$N-,E-} {$ELSE} {$N+,E-} {$ENDIF}
{$ELSE}
{$IFDEF R} {$N-,E-} {$ELSE} {$N+,E+} {$ENDIF}
{$ENDIF}
Uses Crt,Dos,Zita4all;
Const bufsize = 8192; tmax0 = 15300;
{$IFDEF S} e=1.0E-04;tmax:Word=16;  {$ENDIF}
{$IFDEF R} e=1.0E-08;tmax:Word=24;  {$ENDIF}
{$IFDEF D} e=1.0E-12;tmax:Word=32;  {$ENDIF}
{$IFNDEF R}
{$IFNDEF S}
{$IFNDEF D} e=1.0E-16;tmax:Word=40;
{$ENDIF} {$ENDIF} {$ENDIF}
Type Buffer = Array[1..bufsize] Of Byte;
Data = Record
t,e:Real; c:Array[1..2] Of Real;
End;
Var   a1,a2,ci,cie,nonil,nfdat,nfile,
i,j,k,l,np:Integer;
ndat:LongInt;
ratio,h1,h2,hr,ht,weight,percent,
e1,min,max,we2,s2f,s2u,s2,ox,oy,
e3,w3,wyo,wyc,w2yoc,w2yo2,w2yc2,
w3o3,w3oc2,w3o2c,w3c_o3,w4c_o4,
h11,h22,w0,o0,c0,wp,op,cp,wocsc:Real;
c,fitting,method:Char;
d2,dp,dm:Boolean;
hh:String[1];
nparam:String[3];
ename:String[12];
si:String[255];
namefile,expr,dr1,dr2:Pathstr;
bf,bo,bm,bp,bk,be:^Buffer;
inp,out,im,ip,ie,ik:Text;
r:Array[1..tmax0] Of ^Data;
di:SearchRec;
Procedure Stop;
Begin
Messages[1]:='There is an error in DOS-parameters for input!';
Writeln(Output,Messages[1]);Halt(91)
End;
Procedure Miss;
Begin
Messages[1]:='At least one simulated data has not been found!';
Writeln(Output,Messages[1]);Halt(63)
End;
Function LorG:Boolean;
Begin
If nfdat = 1
Then LorG:=(ht < hr) And ((ht+h1*e3) < hr)
Else LorG:=(ht < hr) And ((ht+(r[nfdat]^.t-r[nfdat-1]^.t)*e3) < hr)
End;
Procedure Hp(Var way:Text);
Begin
si:='';c:=' ';
While c <= ' ' Do Read(way,c);
While c > ' ' Do Begin
si:=si+c;Read(way,c)
End 
End;
Procedure Open(Var ii:Text;Var bii:Buffer;ch:PathStr);
Begin
Hp(inp);Assign(ii,ch+'\'+si);SetTextBuf(ii,bii,bufsize);
Is_not_it(ch+'\'+si,ii)
End;
Function Difference(c,i:Integer):Real;
Var                     eg:Boolean;
j:Integer;
act,min,minh,h1,y1,dec:Real;
Function Distance(xx1,yy1,xx2,yy2,xx3,yy3,x0,y0:Real; r:Real):Real;
Var a,b,c,h2,x1,y3,dx,dp:Real;
d:Array[1..3,0..3] Of Real;
ns:Integer;
Function Value(x:Real):Real;
Begin
ox:=x;oy:=(a*x+b)*x+c;
Value:=Sqr(oy-y0)+Sqr(x-x0)
End;
Function First(x:Real):Real;
Begin
First:=((d[1,0]*x+d[1,1])*x+d[1,2])*x+d[1,3]
End;
Function Second(x:Real):Real;
Begin
Second:=(d[2,0]*x+d[2,1])*x+d[2,2]
End;
Function Third(x:Real):Real;
Begin
third:=d[3,0]*x+d[3,1]
End;
Function Xe(x2:Real):Real;
Begin
x1:=x2;x2:=x1-First(x1)/Second(x1);dx:=x2-x1;
Repeat
dp:=dx;x1:=x2;x2:=x1-First(x1)/Second(x1);dx:=x2-x1
Until (Abs(dx) <= e) Or ((dx*dp) < 0.0) Or
(x2 < xx1) Or (x2 > xx3);
Xe:=x2
End;
Function Linear(x,yl,yh:Real):Real;
Var tmp:Real;
Begin
h1:=x;a:=0.0;b:=0.0;c:=r*(yl+yh)/2.0;
If yl > yh Then Begin
tmp:=yl;yl:=yh;yh:=tmp
End;
tmp:=Sqr(x0-x);ox:=x;
If y0 < yl Then Begin
tmp:=tmp+Sqr(y0-yl);c:=r*yl;oy:=yl
End;
If y0 > yh Then Begin
tmp:=tmp+Sqr(y0-yh);c:=r*yh;oy:=yh
End;
Linear:=tmp
End;
Begin
If (Abs(xx1-xx2) < e) Or (Abs(xx1-xx3) < e) Or (Abs(xx2-xx3) < e)
Then Begin
If Abs(xx1-xx2) < e Then y3:=Linear(xx1,yy1,yy2) Else
If Abs(xx2-xx3) < e Then y3:=Linear(xx2,yy2,yy3) Else
If Abs(xx1-xx1) < e Then y3:=Linear(xx1,yy1,yy3)
End 
Else Begin
h1:=(yy1-yy3)/(xx1-xx3);a:=(h1-(yy2-yy3)/(xx2-xx3))/(xx1-xx2);
b:=h1-a*(xx1+xx3);c:=yy1-(a*xx1+b)*xx1;h1:=c-y0;r:=r*r;h2:=a*a;
If a = 0.0
Then y3:=Value((x0+r*b*(y0-c))/(r*b*b+1))
Else Begin
ns:=0;d[1,0]:=1.0;d[1,1]:=1.5*b/a;
d[1,2]:=(a*h1+0.5*b*b+0.5/r)/h2;d[1,3]:=0.5*(b*h1-x0/r)/h2;
d[2,0]:=3.0;d[2,1]:=2*d[1,1];d[2,2]:=d[1,2];
d[3,0]:=6.0;d[3,1]:=d[2,1];
If (First(xx1) < 0.0) And (Second(xx1) > 0.0) And
(Third(xx1) < 0.0)
Then Begin
h1:=Xe(xx1);If (xx1 <= h1) And (h1 <= xx3) Then ns:=1
End;
If (First(xx3) > 0.0) And (Second(xx3) > 0.0) And
(Third(xx3) > 0.0)
Then Begin
h2:=Xe(xx3);If (xx1 <= h2) And (h2 <= xx3) Then Inc(ns,2)
End;
Case ns Of
0:If Value(xx1) < Value(xx3) Then h1:=xx1 Else h1:=xx3;
2:h1:=h2;
3:If Value(h2) < Value(h1) Then h1:=h2
End;
y3:=Value(h1)
End 
End;
y1:=(a*h1+b)*h1+c;Distance:=Sqrt(y3)
End;
Begin
dec:=r[i]^.e-r[i]^.c[c];
If ratio < e Then Difference:=dec
Else Begin
eg:=dec > 0.0;
If (i In [1,nfdat]) Then min:=Abs(dec) Else
min:=Distance(r[i-1]^.t,r[i-1]^.c[c],r[i]^.t,r[i]^.c[c],
r[i+1]^.t,r[i+1]^.c[c],r[i]^.t,r[i]^.e,ratio);
act:=min;j:=i;minh:=act;
While j > 2 Do Begin
j:=j-1;If act < minh Then minh:=act;
act:=Distance(r[j-1]^.t,r[j-1]^.c[c],r[j]^.t,r[j]^.c[c],
r[j+1]^.t,r[j+1]^.c[c],r[i]^.t,r[i]^.e,ratio);
If (eg And (y1 > r[i]^.e)) Or ((Not eg) And (y1 < r[i]^.e)) Or
(Abs(h1-r[i]^.t) > Abs(ratio*dec)) Then j:=1
End;
act:=min;j:=i;
While j < nfdat-1 Do Begin
Inc(j);If act < min Then min:=act;
act:=Distance(r[j-1]^.t,r[j-1]^.c[c],r[j]^.t,r[j]^.c[c],
r[j+1]^.t,r[j+1]^.c[c],r[i]^.t,r[i]^.e,ratio);
If (eg And (y1 > r[i]^.e)) Or ((Not eg) And (y1 < r[i]^.e))
Then j:=nfdat
End;
If minh < min Then min:=minh;
If eg Then Difference:=min Else Difference:=-min
End 
End;
Procedure Err;
Begin
Writeln(out,' 1.1E30');
End;
Begin
ExitSave:=ExitProc;
ExitProc:=@Error_Handling;
ProgramName:='JC';
Messages[1]:='';Messages[2]:='';Messages[3]:='';Messages[4]:='';
Environment;
e3:=e/10.0;
e1:=1.0-e3;
If ParamCount <> 0
Then Begin
namefile:=ParamStr(1);hh:=ParamStr(2);
fitting:=hh[1];
If Not (fitting In ['a','A','r','R','o','O']) Then Stop;
nparam:=ParamStr(3);Val(nparam,i,j);If j <> 0 Then Stop;
If i = 0
Then Begin
nparam:='';method:='0'
End 
Else Begin
hh:=ParamStr(4);method:=hh[1];
If Not (method In ['+','-','p','P']) Then Stop;
Val(ParamStr(5),percent,i);If i <> 0 Then Stop
End 
End 
Else Begin
Write(Output,
'Which file (*.jcd) contains the parameters of curves ? ');
Readln(Input,namefile);
Write(Output,'Which fitting method (A, R or O) will be applied ? ');
Readln(Input,fitting);
If Not (fitting In ['a','A','r','R','o','O']) Then Stop;
Write(Output,'Which k (0,1,2...) was changed during simulation ? ');
Readln(Input,nparam);Val(nparam,i,j);If j <> 0 Then Stop;
If i = 0
Then Begin
nparam:='';method:='0'
End 
Else Begin
Write(Output,'Which method (+,- or P) will be applied ? ');
Readln(Input,method);
If Not (method In ['+','-','p','P']) Then Stop;
Write(Output,
'How many percents were changed the parameters with ? ');
Readln(Input,percent)
End 
End;
New(bf);New(bo);New(bm);New(bp);New(bk);New(be);
tmax:=(MaxAvail Div tmax)-50;
If tmax > tmax0 Then tmax:=tmax0;
Writeln(Output,'Maximum number of the measured data: ',tmax);
If method <> '0' Then percent:=percent/100.0;
dp:=method = '+';dm:=method = '-';d2:= method In ['p','P'];
If Pos('.',namefile) = 0 Then namefile:=namefile+'.jcd';
namefile:=ZitaTemp+'\'+namefile;
Assign(inp,namefile);SetTextBuf(inp,bf^,bufsize);
Is_not_it(namefile,inp);
Readln(inp,a1,a2);
FindFirst(ZitaTemp+'\j'+nparam+'.col',AnyFile,di);
If DosError = 0 Then Begin
Assign(out,ZitaTemp+'\j'+nparam+'.col');Erase(out)
End;
Assign(out,ZitaTemp+'\tmp.col');SetTextBuf(out,bo^,bufsize);
Rewrite(out);
Val(nparam,np,i);
nfile:=0;ndat:=0;s2:=0.0;s2f:=0.0;nonil:=0;
w2yoc:=0.0;wyo:=0.0;wyc:=0.0;w2yo2:=0.0;w2yc2:=0.0;
w3o3:=0.0;w3oc2:=0.0;w3o2c:=0.0;w3c_o3:=0.0;w4c_o4:=0.0;wocsc:=0.0;
If a1 = 0 Then dr1:=ZitaSimu Else dr1:=ZitaRd;
If a2 = 0 Then dr2:=ZitaSimu Else dr2:=ZitaRd;
Writeln(Output,
'The program is using the experimental data of column ');
Repeat
Inc(nfile);
expr:=ZitaExpr;Open(ie,be^,expr);ename:=si;
Read(inp,cie,i);
GotoXY(54,WhereY-1);HighVideo;Write(Output,cie);LowVideo;
Write(Output,' of ');HighVideo;Write(Output,si);LowVideo;
Writeln(Output,Copy('.               ',1,15-Length(si)));
no:=False;
If i < 0 Then Begin
si:='';c:=' ';
While c <> '[' Do Read(inp,c);
si:=c;
Repeat
Read(inp,c);si:=si+c
Until c = ']';
Read(inp,c);
If method <> '0' Then no:=NeedCalc(si,np)
End;
If i < -30000 Then i:=0 Else i:=Abs(i);
If i <> 0 Then For j:=1 To i Do Readln(ie);
Readln(ie,h2);
While Not SeekEof(ie) Do Readln(ie,h1);
h1:=h1-h2;
Reset(ie);
If i <> 0 Then For j:=1 To i Do Readln(ie);
If no Then Begin
Readln(inp);
Close(ie);
Assign(ie,ZitaTemp+'\j.col');SetTextBuf(ie,be^,bufsize);Reset(ie);
Readln(ie,i,nfdat);
While (i < nfile) And (Not SeekEof(ie)) Do Begin
For i:=1 To nfdat Do Readln(ie);
Readln(ie,i,nfdat)
End;
If (SeekEof(ie)) Or (i > nfile) Then nfdat:=0;
(*
nfdat:=0;
If Not SeekEof(ie) Then
Repeat
For i:=1 To cie Do Hp(ie);
If Ord(c) <> 13 Then Readln(ie);
Val(si,hr,i);
If i = 0 Then Inc(nfdat)
Until SeekEof(ie) Or (nfdat = tmax);
*)
Close(ie);
If nfdat > 0
Then Begin
Writeln(out);
For i:=1 To nfdat Do Writeln(out,'0')
End 
Else nfile:=nfile-1
End 
Else Begin
If d2 Then Hp(inp) Else Open(ik,bk^,dr1);
Read(inp,ci,weight);we2:=Sqr(weight);w3:=we2*weight;
If d2 Or dp Then Open(ip,bp^,dr2);
If d2 Or dm Then Open(im,bm^,dr2);
If fitting In ['o','O'] Then Begin
ratio:=-1.0;
While (Ord(c) <> 13) And (Not SeekEoln(inp)) And (ratio < 0.0)
Do Begin
Hp(inp);Val(si,ratio,i);
If i = 0 Then ratio:=Abs(ratio) Else ratio:=-1.0
End;
If ratio < 0.0 Then ratio:=1.0
End;
If Ord(c) <> 13 Then Readln(inp);
nfdat:=0;
Repeat
Inc(nfdat);
If nfdat > nonil Then Begin
nonil:=nfdat;New(r[nfdat])
End;
j:=0;
Read(ie,r[nfdat]^.t);
If r[nfdat]^.t >= 0.0
Then hr:=e1*r[nfdat]^.t
Else hr:=r[nfdat]^.t/e1;
For i:=2 To cie Do Hp(ie);
If Ord(c) <> 13 Then Readln(ie);
Val(si,r[nfdat]^.e,i);
If i > 0 Then Inc(j);
If Not d2 Then Begin
Read(ik,ht);
While LorG Do Begin
If SeekEof(ik) Then Miss;
Readln(ik);Read(ik,ht)
End;
For i:=2 To ci Do Hp(ik);
If Ord(c) <> 13 Then Readln(ik);
Val(si,r[nfdat]^.c[2],i);
If i > 0
Then Inc(j)
Else If dm Then r[nfdat]^.c[1]:=r[nfdat]^.c[2]
End;
If d2 Or dp Then Begin
Read(ip,ht);
While LorG Do Begin
If SeekEof(ip) Then Miss;
Readln(ip);Read(ip,ht)
End;
For i:=2 To ci Do Hp(ip);
If Ord(c) <> 13 Then Readln(ip);
Val(si,r[nfdat]^.c[1],i);
If i > 0 Then Inc(j)
End;
If d2 Or dm Then Begin
Read(im,ht);
While LorG Do Begin
If SeekEof(im) Then Miss;
Readln(im);Read(im,ht)
End;
For i:=2 To ci Do Hp(im);
If Ord(c) <> 13 Then Readln(im);
Val(si,r[nfdat]^.c[2],i);
If i > 0 Then Inc(j)
End;
If j > 0 Then nfdat:=nfdat-1
Until SeekEof(ie) Or (nonil = tmax);
Close(ie);
If Not d2 Then Close(ik);
If d2 Or dp Then Close(ip);
If d2 Or dm Then Close(im);
If (fitting In ['r','R','o','O']) And (nfdat > 1) Then Begin
min:=r[1]^.e;max:=min;
For i:=2 To nfdat Do Begin
If r[i]^.e > max Then max:=r[i]^.e;
If r[i]^.e < min Then min:=r[i]^.e
End;
max:=max-min;
If fitting In ['o','O'] Then Begin
For i:=1 To nfdat Do Begin
r[i]^.e:=(r[i]^.e-min)/max;r[i]^.c[2]:=(r[i]^.c[2]-min)/max;
If method In ['+','-','p','P']
Then r[i]^.c[1]:=(r[i]^.c[1]-min)/max
End;
min:=r[nfdat]^.t-r[1]^.t;
For i:=nfdat Downto 1 Do r[i]^.t:=(r[i]^.t-r[1]^.t)/min
End 
End;
If nfdat > 0 Then
For i:=1 To nfdat Do Begin
If method = '0'
Then Begin
If fitting In ['o','O']
Then Begin
h1:=Sqrt(Sqr(r[i]^.e)+Sqr(r[i]^.t));h2:=h1+Difference(2,i)
End 
Else Begin
h1:=r[i]^.e;h2:=r[i]^.c[2];
If fitting In ['r','R'] Then Begin
h1:=h1/max;h2:=h2/max
End 
End;
h11:=h1*h1;h22:=h2*h2;
w2yoc:=w2yoc+we2*h1*h2;
wyo:=wyo+weight*h1;wyc:=wyc+weight*h2;
w2yo2:=w2yo2+we2*h11;w2yc2:=w2yc2+we2*h22;
w3o3:=w3o3+w3*h11*h1;
w3oc2:=w3oc2+w3*h22*h1;w3o2c:=w3o2c+w3*h11*h2;
h11:=h2-h1;
w3c_o3:=w3c_o3+w3*h11*h11*h11;
w4c_o4:=w4c_o4+w3*weight*Sqr(h11*h11);
If (ndat = 0) And (i = 1)
Then Begin
w0:=weight;o0:=h1;c0:=h2;wp:=w0;op:=o0;cp:=c0
End 
Else Begin
wocsc:=wocsc+weight*(h11)*wp*(cp-op);
wp:=weight;op:=h1;cp:=h2
End;
If fitting In ['o','O']
Then r[i]^.e:=h2-h1
Else r[i]^.e:=r[i]^.e-r[i]^.c[2]
End 
Else
If fitting In ['o','O']
Then r[i]^.e:=(Difference(2,i)-Difference(1,i))/percent
Else r[i]^.e:=(r[i]^.c[1]-r[i]^.c[2])/percent;
If method In ['p','P'] Then r[i]^.e:=r[i]^.e/2.0
End;
If (fitting In ['r','R']) And (nfdat > 1) Then
For i:=1 To nfdat Do r[i]^.e:=r[i]^.e/max;
If ((nfdat > 0) And (fitting In ['a','A'])) Or
((nfdat > 1) And (fitting In ['r','R','o','O']))
Then Begin
If method = '0' Then Begin
Write(out,nfile:4,'     ',nfdat:5,' ');
s2u:=0.0;
For i:=1 To nfdat Do Begin
s2u:=s2u+Sqr(r[i]^.e);s2f:=s2f+Sqr(weight*r[i]^.e)
End;
Write(out,
Swr(Sqrt(s2u/nfdat),ac,1),' ',Swr(weight,14,1),'  ',ename);
Inc(ndat,nfdat);s2:=s2+s2u
End;
Writeln(out);
For i:=1 To nfdat Do Begin
Write(out,Swr(r[i]^.e,ac,2));
If method = '0'
Then Writeln(out,' ',Swr(r[i]^.t,ac,2))
Else Writeln(out)
End 
End 
Else nfile:=nfile-1
End 
Until SeekEof(inp);
Close(inp);
If method = '0' Then Begin
Writeln(out,0);
Writeln(out,'Number of points = ',ndat:7,
'     Fitting = ',Swr(Sqrt(s2f/ndat),ac,1));
Writeln(out,'Unweighted Fitting = ',Swr(Sqrt(s2/ndat),ac,1));
h11:=(w2yo2+w2yc2-2.0*w2yoc);
If h11 < 0.0 Then h11:=0.0;
h22:=(w2yo2-wyo*wyo/ndat);
If h22 < 0.0 Then h22:=0.0;
h1:=h22*(w2yc2-wyc*wyc/ndat);
Write(out,'Correlation = ');
If h1 <= 0.0 Then Err
Else Writeln(out,Swr((w2yoc-wyo*wyc/ndat)/(Sqrt(h1)),ac,1));
Write(out,'Coeff. of det. = ');
If h22 = 0.0 Then Err Else Writeln(out,Swr(1.0-h11/h22,ac,1));
Write(out,'R-squared = ');
If w2yo2 = 0.0 Then Err
Else Writeln(out,Swr(Abs(w2yc2-2.0*w2yoc)/w2yo2,ac,1));
Write(out,'First term of MSC = ');
If h11 = 0.0 Then Err
Else
If h22/h11 <= 0.0 Then Err
Else Writeln(out,Swr(Ln(h22/h11),ac,1));
wocsc:=wocsc+w0*(c0-o0)*wp*(cp-op);
Write(out,'Serial Correlation = ');
If (ndat < 1) Or (h11 = 0.0) Then Err
Else Writeln(out,Swr(Sqrt(ndat-1)*wocsc/h11,ac,1));
h1:=h11*h22;
Write(out,'Heteroscedactivity = ');
If (ndat < 3) Or (h1 = 0.0) Then Err
Else Writeln(out,Swr((ndat-1)/(ndat-2)*wyo*
(w3o3+w3oc2-2.0*w3o2c-wyo/ndat*h11)/h1,ac,1));
h11:=Sqrt(h11/(ndat-1));
Write(out,'Skewness = ');
If h11 = 0.0 Then Err
Else Writeln(out,Swr(w3c_o3/h11/h11/h11/ndat/Sqrt(6.0/ndat),ac,1));
Write(out,'Kurtosis = ');
If h11 = 0.0 Then Err
Else Writeln(out,
Swr((w4c_o4/Sqr(h11*h11)/ndat-3)/Sqrt(24.0/ndat),ac,1));
End;
Close(out);Rename(out,ZitaTemp+'\j'+nparam+'.col');
{$IFDEF MSDOS} Release(HeapOrg) {$ENDIF}
End.
End.
